"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.createMutation = createMutation;

var _graphqlRelay = require("graphql-relay");

var _field = require("./field");

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

/* global IGraphQuillMutation */
function createMutation(wrappedFunc, _ref, args, fields, connections) {
  var name = _ref.name;
  var description = _ref.description;

  wrappedFunc.GraphQuill = function (nodeInterface) {
    wrappedFunc.GraphQLMutations = {};
    var outFieldsList = [].concat((0, _field.fieldMapping)(fields, nodeInterface), connections && (0, _field.connMapping)(connections, nodeInterface) || []);
    wrappedFunc.GraphQLMutations[name] = (0, _graphqlRelay.mutationWithClientMutationId)({
      name: name.slice(0, 1).toUpperCase() + name.slice(1),
      description: description,
      inputFields: (0, _field.argMapping)(args, nodeInterface),
      outputFields: Object.assign.apply(Object, [{}].concat(_toConsumableArray(outFieldsList))),
      mutateAndGetPayload: wrappedFunc
    });
    return wrappedFunc;
  };
  return wrappedFunc;
}